function varargout = peakfitting_GUI(varargin)
% PEAKFITTING_GUI M-file for peakfitting_GUI.fig
%      PEAKFITTING_GUI, by itself, creates a new PEAKFITTING_GUI or raises the existing
%      singleton*.
%
%      H = PEAKFITTING_GUI returns the handle to a new PEAKFITTING_GUI or the handle to
%      the existing singleton*.
%
%      PEAKFITTING_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PEAKFITTING_GUI.M with the given input arguments.
%
%      PEAKFITTING_GUI('Property','Value',...) creates a new PEAKFITTING_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before peakfitting_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to peakfitting_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help peakfitting_GUI

% Last Modified by GUIDE v2.5 15-Dec-2017 11:12:32

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @peakfitting_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @peakfitting_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});clc
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT


% --- Executes on button press in Load_Param.
function Load_Param_Callback(hObject, eventdata, handles)
% hObject    handle to Load_Param (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
param = importdata('parameter_file');

set(handles.positionstxt,'String',num2str(param.data(1,:)));
set(handles.widthstxt,'String',num2str(param.data(2,:)));
set(handles.ampstxt,'String',num2str(param.data(3,:)));
set(handles.ratiostxt,'String',num2str(param.data(4,:)));
set(handles.Xmintxt,'String',num2str(param.data(5,1)));
set(handles.Xmaxtxt,'String',num2str(param.data(6,1)));
set(handles.Switch_to_New_Params,'Enable','off') 
if handles.data_loaded
set(handles.simulate_data,'Enable','on') 
set(handles.Fit_Data,'Enable','on') 
end

set(handles.nb_peakstxt,'String',num2str(length(param.data(1,:))));

handles.positions = param.data(1,:);
handles.widths = param.data(2,:);
handles.amplitudes = param.data(3,:);
handles.ratios = param.data(4,:);
handles.Xmin = param.data(5,1);
handles.Xmax = param.data(6,1);
handles.nb_peaks = length(param.data(1,:));
handles.params_loaded = 1;

guidata(hObject, handles);


% --- Executes just before peakfitting_GUI is made visible.
function peakfitting_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to peakfitting_GUI (see VARARGIN)

% Choose default command line output for peakfitting_GUI
handles.data = [0 1; 0 1];
handles.output = hObject;
handles.PathName = pwd;
handles.Xmin = 1100;
handles.Xmax = 1800;
handles.positions = 0;
handles.positionsErr = 0;
handles.widths = 0;
handles.widthsErr = 0;
handles.amplitudes = 0;
handles.amplitudesErr = 0;
handles.ratios = 0;
handles.ratiosErr = 0;
handles.nb_peaks = 0;
handles.position_range = 0;
handles.width_range = 0;
handles.amplitude_range = 0;
handles.ratio_range = 0;
set(handles.D2_visible,'value',0);
handles.R1 = 0;
handles.R2 = 0;
handles.R1Err = [0,0];
handles.R2Err = [0,0];
handles.D1Err = [0,0];
handles.GErr = [0,0];
handles.Saddle_fit = 0;
handles.Saddle_data = 0;
handles.D_to_G = 0;
set(handles.Switch_to_New_Params,'Enable','off') 
set(handles.simulate_data,'Enable','off') 
set(handles.Fit_Data,'Enable','off') 
handles.params_loaded = 0;
handles.data_loaded = 0;
set(handles.Man_bkg_adj_txt,'value',0);
handles.Man_bkg_adj = 0;
handles.bkgInt = 0;
handles.bkgRatio_1350 = 0;
handles.bkgRatio_1600 = 0;
handles.slope = 0;
handles.slopeRatio_1350 = 0;
handles.slopeRatio_1600 = 0;
handles.nbAcquisitions = 1;

handles.roughD1pos = 1595;
handles.roughD2pos = 1620;
handles.roughGpos = 1335;
Xmax = num2str(handles.Xmax);
set(handles.Xmaxtxt,'String',Xmax);
Xmin = num2str(handles.Xmin);
set(handles.Xmintxt,'String',Xmin);


% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using peakfitting_GUI.

% UIWAIT makes peakfitting_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = peakfitting_GUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in Fit_Data.
function Fit_Data_Callback(hObject, eventdata, handles)
% hObject    handle to Fit_Data (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.Fit_figure);
xmin = handles.Xmin;
xmax = handles.Xmax;

A = handles.data;

if xmax > max(A(:,1))
    xmax = max(A(:,1));
end
if xmin < min(A(:,1))
    xmin = min(A(:,1));
end

rangemin = find(A(:,1)>=xmin,1);
rangemax = find(A(:,1)>=xmax,1);

x = handles.data(rangemin:rangemax,1);
y = handles.data(rangemin:rangemax,2);
[b,ind] = min(y);
base = mean(handles.data(rangemin+ind-2:rangemin+ind+2,2));
y = y-base;

if (get(handles.Slope_bkg,'Value') == get(handles.Slope_bkg,'Max'))
    ystart = mean(y(1:5));
    yend = mean(y(length(y)-4:length(y)));
    handles.slope = (yend-ystart)./(xmax-xmin); % slope in counts / cm-1
    if ystart < yend
        slope = y.*0;
        for i = 0:length(y)-1
            slope(i+1) = yend.*i/length(y);
        end
    else
        slope = y.*0;
        for i = 0:length(y)-1
            slope(length(y)-i) = ystart.*i/length(y);
        end
    end
    y = y-slope;
    bkSlope = slope+base-handles.nbAcquisitions.*120;
    handles.bkgInt = sum(bkSlope);
    handles.bkgRatio_1350 = max(y(find(x>1200,1):find(x>1450,1)))./handles.bkgInt; % scale to the maximum intensity between 1200 and 1450 cm-1
    handles.bkgRatio_1600 = max(y(find(x>1500,1):find(x>1700,1)))./handles.bkgInt; % scale to the maximum intensity between 1500 and 1700 cm-1
    handles.slopeRatio_1350 = max(y(find(x>1200,1):find(x>1450,1)))./handles.slope; % scale the max int to the slope (cm-1)
    handles.slopeRatio_1600 = max(y(find(x>1500,1):find(x>1700,1)))./handles.slope; % scale the max int to the slope (cm-1)
else
    handles.bkgInt = 0;
    handles.bkgRatio_1350 = 0;
    handles.bkgRatio_1600 = 0;
    handles.slope = 0;
    handles.slopeRatio_1350 = 0;
    handles.slopeRatio_1600 = 0;
end
y = y-handles.Man_bkg_adj;

startpoint.position = handles.positions;
startpoint.width = handles.widths;
startpoint.amplitude = handles.amplitudes;
startpoint.ratio = handles.ratios;
nbpeaks = handles.nb_peaks;
constraints.position = zeros(nbpeaks,1) + handles.position_range';
constraints.width = zeros(nbpeaks,1) + handles.width_range';
constraints.amplitude = zeros(nbpeaks,1) + handles.amplitude_range';
constraints.ratio = zeros(nbpeaks,1) + handles.ratio_range';

% fit_results = multi_mix_struc(x,y,startpoint,nbpeaks,constraints)  %old fit
%%%%%%%%%
[fitresult, gof] = createFit(x,y,startpoint,nbpeaks,constraints)   % new fit
%%%%%%%%%%
fit_results = coeffvalues(fitresult);
Ci = confint(fitresult,0.67)' % one sigma error center/width/amplitude/peakratio 


axes(handles.Fit_figure);
plot(x,y,'b.')
hold on
j = 1;
center = zeros(1,nbpeaks,1);
sigma = zeros(1,nbpeaks,1);
amp = zeros(1,nbpeaks,1);
peakratio = zeros(1,nbpeaks,1);
center_Err = zeros(nbpeaks,2);
sigmaErr = zeros(nbpeaks,2);
ampErr = zeros(nbpeaks,2);

for i = 1:4:length(fit_results)
    center(j) = fit_results(i);
    center_Err(j,:) = Ci(i,:);
    sigma(j)= fit_results(i+1);
    sigmaErr(j,:) = Ci(i+1,:);
    amp(j) = fit_results(i+2);
    ampErr(j,:) = Ci(i+2,:);
    peakratio(j) = fit_results(i+3);
    j = j + 1;
end
handles.fitted_positions = center;
handles.fitted_width = sigma;
handles.fitted_amplitudes = amp;
handles.fitted_ratio = peakratio;
area = zeros(1,nbpeaks);
Ymax = max(y);

FittedCurve = 0.*y;
eachFit = zeros(length(y),nbpeaks);
areaErr = zeros(nbpeaks,2);
        for i = 1:nbpeaks
        FittedCurve = amp(i).* ((1-peakratio(i)).*gaussian(x,center(i),sigma(i)) + peakratio(i).*lorentzian(x,center(i),sigma(i)))+FittedCurve;
        eachFit(:,i) = amp(i).* ((1-peakratio(i)).*gaussian(x,center(i),sigma(i)) + peakratio(i).*lorentzian(x,center(i),sigma(i)));
        plot(x,eachFit(:,i),'k');
        area(i) = amp(i)*sigma(i)*(peakratio(i)*0.5*pi+(1-peakratio(i))*(0.6*sqrt(pi)));
        areaErr(i,:) = ampErr(i,:).*sigmaErr(i,:).*(peakratio(i)*0.5*pi+(1-peakratio(i))*(0.6*sqrt(pi)));
        end
        handles.fitted_area = area;
h0 = plot(x,FittedCurve,'r','LineWidth',3);

% show the saddle peak
    yl = ylim;
if (get(handles.Saddle_OnOff,'Value')== 1)
    [handles.Saddle_fit,ind] = min(FittedCurve(find(x>1400,1):find(x>1600,1)));
    h = text(x(ind+find(x>1400,1)),handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./4,num2str(handles.Saddle_fit));
    set(h,'Rotation',90,'color','r','FontWeight','bold','HorizontalAlignment','center');
    handles.Saddle_data = mean(y(ind+find(x>1400,1)-10:ind+find(x>1400,1)+10));
    h = text(x(ind+find(x>1400,1))+15,handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./4,num2str(handles.Saddle_data));
    set(h,'Rotation',90,'color','b','FontWeight','bold','HorizontalAlignment','center');
end
% show the distance between peaks in 2 peaks case
if length(center)==2 
    handles.D_to_G = round(10.*(center(2)-center(1)))./10;
    text(center(1)+0.5.*handles.D_to_G,handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./2,num2str(handles.D_to_G),'HorizontalAlignment','center','VerticalAlignment','top');
    quiver([center(1) 000],[handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./2 000], [center(2)-center(1),0], [0,0] , 0,'k','MaxHeadSize',0.05,'LineWidth',2)
    quiver([center(2) 000],[handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./2 000], [center(1)-center(2),0], [0,0] , 0,'k','MaxHeadSize',0.05,'LineWidth',2)
else
    handles.D_to_G = 0;
end

xlim([xmin xmax])
hold off
axes(handles.residual_figure);
diff = y - FittedCurve;
chi = sum(diff.^2)
plot(x,diff,'k')
text((xmax-xmin)./2+xmin,2.*max(diff),['chi^2 = ',num2str(chi,4)],'FontWeight','bold','HorizontalAlignment','left');

xlim([xmin xmax]);

D1_A = 0;
D2_A = 0;
G_A = 0;
D1_H = 0;
D2_H = 0;
G_H = 0;
D1_Center_Err = [0,0];
G_Center_Err = [0,0];
testG = 0;
testD = 0;
testD2 = 0;


peak_assign = 5;
if (get(handles.Fine_assignment,'Value') == get(handles.Fine_assignment,'Max'))
    peak_assign = 0.7;
end

    
if (get(handles.D2_visible,'Value') == get(handles.D2_visible,'Max'))
    for i = 1:nbpeaks
        if center(i) >=handles.roughD1pos-peak_assign && center(i) <= handles.roughD1pos+peak_assign
            if testD ==0
            axes(handles.Fit_figure);
            hold on
            h1 = plot(x,eachFit(:,i),'-m');
            hold off
            D1_A = area(i);
            D1_H = amp(i);
            D1_Center_Err = center_Err(i,:)
            D1_A_Err = areaErr(i,:)
            D1_H_Err = ampErr(i,:);
            testD = 1;
            else
              hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        elseif center(i) >=handles.roughD2pos-peak_assign && center(i) <= handles.roughD2pos+peak_assign
            if testD2 ==0
            axes(handles.Fit_figure);
            hold on
            h2 = plot(x,eachFit(:,i),'-y');
            hold off
            D2_A = area(i);
            D2_H = amp(i);
            D2_A_Err = areaErr(i,:);
            D2_H_Err = ampErr(i,:);

            testD2 = 1;
            else
              hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        elseif center(i) >=handles.roughGpos-peak_assign && center(i) <= handles.roughGpos+peak_assign
            if testG ==0
            axes(handles.Fit_figure);
            hold on
            h3 = plot(x,eachFit(:,i),'-g');
            hold off
            G_A = area(i);
            G_H = amp(i);
            G_Center_Err = center_Err(i,:)
            G_A_Err = areaErr(i,:);
            G_H_Err = ampErr(i,:);
            testG = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end

        end
    end
        if testG == 1 && testD ==1 && testD2 == 1 && (get(handles.legend_on_off,'Value') == get(handles.RatioCalc,'Max'))
            legend([h0 h1 h3 h2],'total simulated profile','D1 peak','D2 peak','G peak')
        end
else
    testG = 0;
    testD = 0;
    for i = 1:nbpeaks
        if center(i) >=handles.roughD1pos-peak_assign && center(i) <= handles.roughD1pos+peak_assign
            if testD ==0
            axes(handles.Fit_figure);
            hold on
            h1 = plot(x,eachFit(:,i),'-m');
            hold off
            D1_A = area(i);
            D1_H = amp(i);
            D1_Center_Err = center_Err(i,:)
            D1_A_Err = areaErr(i,:);
            D1_H_Err = ampErr(i,:);
            testD = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        elseif center(i) >=handles.roughGpos-peak_assign && center(i) <= handles.roughGpos+peak_assign
            if testG == 0
            axes(handles.Fit_figure);
            hold on
            h2 = plot(x,eachFit(:,i),'-g');
            hold off
            G_A = area(i);
            G_H = amp(i);
            G_Center_Err = center_Err(i,:)
            G_A_Err = areaErr(i,:);
            G_H_Err = ampErr(i,:);
            testG = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        end
    end
    D2_A = 0;
    D2_A_Err = zeros(1,2);
    peak_assign;
    if testG == 1 && testD ==1 && (get(handles.legend_on_off,'Value') == get(handles.RatioCalc,'Max'))
    legend([h0 h1 h2],'total simulated profile','D1 peak','G peak',2)
    end
end

if (get(handles.RatioCalc,'Value') == get(handles.RatioCalc,'Max'))
    set(handles.R2_res_txt, 'String', 'R2 = whattttt');
    set(handles.R1_res_txt, 'String', 'R1 = whattttt');
    if D1_A && G_A
        R2 = D1_A./(G_A + D1_A+D2_A)
        R2Err(1) = D1_A_Err(1)./(G_A_Err(2) + D1_A_Err(2)+D2_A_Err(2));
        R2Err(2) = D1_A_Err(2)./(G_A_Err(1) + D1_A_Err(1)+D2_A_Err(1));
        R1 = D1_H./G_H;
        R1Err(1) = D1_H_Err(1)./G_H_Err(2);
        R1Err(2) = D1_H_Err(2)./G_H_Err(1);
        R1ErrVal = (R1Err(2)-R1Err(1))./2;
        R2ErrVal = (R2Err(2)-R2Err(1))./2;
        handles.R1 = R1;
        handles.R2 = R2;
        handles.R1Err = R1Err;
        handles.R2Err = R2Err;
        set(handles.R2_res_txt, 'String', ['R2 = ',num2str(R2,3),' +/-',num2str(R2ErrVal,2)]);
        set(handles.R1_res_txt, 'String', ['R1 = ',num2str(R1,3),' +/-',num2str(R1ErrVal,2)]);
        handles.D1Err = D1_Center_Err;
        handles.GErr = G_Center_Err;
    else
        h = msgbox('please click on the D peak center and G peak center buttons to refine the rough position','error','error')
    end
end

% create the figure to be exported
     
clf(figure(1))
figure(1);

     hax=axes('Position',[0.1,0.35,0.85,0.63]);
     plot(hax,x,y)
     hold on
     for i = 1:nbpeaks
        plot(x,eachFit(:,i),'k');
     end
     plot(hax,x,FittedCurve,'r')
     set(hax,'XTick',[])
     set(hax,'XTickLabel',[])
     hold off
     xlim([xmin xmax])
     ylabel('Intensity (cts)')
     hax = axes('Position',[0.1,0.1,0.85,0.20]);
     plot(hax,x,diff,'k')
          xlim([xmin xmax])
     xlabel('Raman Shift (cm^-^1)')
     filename = [handles.FileName '.pdf'];
     print(figure(1),'-dpdf', filename)
outputdata = [x y FittedCurve eachFit];
filename = [handles.FileName 'fit.csv'];
dlmwrite(filename,outputdata);
set(handles.Switch_to_New_Params,'Enable','on') 
guidata(hObject, handles);


% --- Executes on button press in simulate_data.
function simulate_data_Callback(hObject, eventdata, handles)
% hObject    handle to simulate_data (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.Fit_figure);
xmin = handles.Xmin;
xmax = handles.Xmax;

A = handles.data;

if xmax > max(A(:,1))
    xmax = max(A(:,1));
end
if xmin < min(A(:,1))
    xmin = min(A(:,1));
end

rangemin = find(A(:,1)>=xmin,1);
rangemax = find(A(:,1)>=xmax,1);

x = handles.data(rangemin:rangemax,1);
y = handles.data(rangemin:rangemax,2);
[b,ind] = min(y);
base = mean(handles.data(rangemin+ind-2:rangemin+ind+2,2));
y = y-base;

if (get(handles.Slope_bkg,'Value') == get(handles.Slope_bkg,'Max'))
    ystart = mean(y(1:5));
    yend = mean(y(length(y)-4:length(y)));
    handles.slope = (yend-ystart)./(xmax-xmin); % slope in counts / cm-1
    if ystart < yend
        slope = y.*0;
        for i = 0:length(y)-1
            slope(i+1) = yend.*i/length(y);
        end
    else
        slope = y.*0;
        for i = 0:length(y)-1
            slope(length(y)-i) = ystart.*i/length(y);
        end
    end
    y = y-slope;
    bkSlope = slope+base-handles.nbAcquisitions.*120;
    handles.bkgInt = sum(bkSlope);
    handles.bkgRatio_1350 = max(y(find(x>1200,1):find(x>1450,1)))./handles.bkgInt; % scale to the maximum intensity between 1200 and 1450 cm-1
    handles.bkgRatio_1600 = max(y(find(x>1500,1):find(x>1700,1)))./handles.bkgInt; % scale to the maximum intensity between 1500 and 1700 cm-1
    handles.slopeRatio_1350 = max(y(find(x>1200,1):find(x>1450,1)))./handles.slope; % scale the max int to the slope (cm-1)
    handles.slopeRatio_1600 = max(y(find(x>1500,1):find(x>1700,1)))./handles.slope; % scale the max int to the slope (cm-1)
else
    handles.bkgInt = 0;
    handles.bkgRatio_1350 = 0;
    handles.bkgRatio_1600 = 0;
    handles.slope = 0;
    handles.slopeRatio_1350 = 0;
    handles.slopeRatio_1600 = 0;
end
y = y-handles.Man_bkg_adj;

nbpeaks = handles.nb_peaks;
axes(handles.Fit_figure);
plot(x,y,'b.')
hold on
center = handles.positions;
sigma = handles.widths;
amp = handles.amplitudes;
peakratio = handles.ratios;

handles.fitted_positions = center;
handles.fitted_width = sigma;
handles.fitted_amplitudes = amp;
handles.fitted_ratio = peakratio;
area = zeros(1,nbpeaks);
Ymax = max(y);

FittedCurve = 0.*y;
        for i = 1:nbpeaks
        FittedCurve = amp(i).* ((1-peakratio(i)).*gaussian(x,center(i),sigma(i)) + peakratio(i).*lorentzian(x,center(i),sigma(i)))+FittedCurve;
        eachFit(:,i) = amp(i).* ((1-peakratio(i)).*gaussian(x,center(i),sigma(i)) + peakratio(i).*lorentzian(x,center(i),sigma(i)));
        plot(x,eachFit(:,i),'k');
        area(i) = amp(i)*sigma(i)*(peakratio(i)*0.5*pi+(1-peakratio(i))*(0.6*sqrt(pi)));
        end
        handles.fitted_area = area;
h0 = plot(x,FittedCurve,'r','LineWidth',3)
    yl = ylim;

% show the saddle peak
if (get(handles.Saddle_OnOff,'Value')== 1)
    [handles.Saddle_fit,ind] = min(FittedCurve(find(x>1400,1):find(x>1600,1)));
    h = text(x(ind+find(x>1400,1)),handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./4,num2str(handles.Saddle_fit));
    set(h,'Rotation',90,'color','r','FontWeight','bold','HorizontalAlignment','center');
    handles.Saddle_data = mean(y(ind+find(x>1400,1)-10:ind+find(x>1400,1)+10));
    h = text(x(ind+find(x>1400,1))+15,handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./4,num2str(handles.Saddle_data));
    set(h,'Rotation',90,'color','b','FontWeight','bold','HorizontalAlignment','center');
end

% show the distance between peaks in 2 peaks case
if length(center)==2 
    handles.D_to_G = round(10.*(center(2)-center(1)))./10;
    text(center(1)+0.5.*handles.D_to_G,handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./2,num2str(handles.D_to_G),'HorizontalAlignment','center','VerticalAlignment','top');
    quiver([center(1) 000],[handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./2 000], [center(2)-center(1),0], [0,0] , 0,'k','MaxHeadSize',0.05,'LineWidth',2)
    quiver([center(2) 000],[handles.Saddle_fit+(yl(2)-handles.Saddle_fit)./2 000], [center(1)-center(2),0], [0,0] , 0,'k','MaxHeadSize',0.05,'LineWidth',2)
else
    handles.D_to_G = 0;
end


xlim([xmin xmax]);
hold off

axes(handles.residual_figure);
diff = y - FittedCurve;
chi = sum(diff.^2)
plot(x,diff,'k')
text((xmax-xmin)./2+xmin,2.*max(diff),['chi^2 = ',num2str(chi,4)],'FontWeight','bold','HorizontalAlignment','left');

xlim([xmin xmax])

D1_A = 0;
D2_A = 0;
G_A = 0;
D1_H = 0;
D2_H = 0;
G_H = 0;

    testG = 0;
    testD = 0;
    testD2 = 0;

peak_assign = 5;
if (get(handles.Fine_assignment,'Value') == get(handles.Fine_assignment,'Max'))
    peak_assign = 0.7;
end
    
if (get(handles.D2_visible,'Value') == get(handles.D2_visible,'Max'))
    for i = 1:nbpeaks
        if center(i) >=handles.roughD1pos-peak_assign && center(i) <= handles.roughD1pos+peak_assign
            if testD ==0
            axes(handles.Fit_figure);
            hold on
            h1 = plot(x,eachFit(:,i),'-m');
            hold off
            D1_A = area(i);
            D1_H = amp(i);
            testD = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        elseif center(i) >=handles.roughD2pos-peak_assign && center(i) <= handles.roughD2pos+peak_assign
            if testD2 ==0
            axes(handles.Fit_figure);
            hold on
            h2 = plot(x,eachFit(:,i),'-y');
            hold off
            D2_A = area(i);
            D2_H = amp(i);
            testD2 = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        elseif center(i) >=handles.roughGpos-peak_assign && center(i) <= handles.roughGpos+peak_assign
            if testG ==0
            axes(handles.Fit_figure);
            hold on
            h3 = plot(x,eachFit(:,i),'-g');
            hold off
            G_A = area(i);
            G_H = amp(i);
            testG = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end

        end
    end
        if testG == 1 && testD ==1 && testD2 == 1 && (get(handles.legend_on_off,'Value') == get(handles.RatioCalc,'Max'))
            legend([h0 h1 h3 h2],'total simulated profile','D1 peak','D2 peak','G peak')
        end
else
    testG = 0;
    testD = 0;
    for i = 1:nbpeaks
        if center(i) >=handles.roughD1pos-peak_assign && center(i) <= handles.roughD1pos+peak_assign
            if testD ==0
            axes(handles.Fit_figure);
            hold on
            h1 = plot(x,eachFit(:,i),'-m');
            hold off
            D1_A = area(i);
            D1_H = amp(i);
            testD = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        elseif center(i) >=handles.roughGpos-peak_assign && center(i) <= handles.roughGpos+peak_assign
            if testG == 0
            axes(handles.Fit_figure);
            hold on
            h2 = plot(x,eachFit(:,i),'-g');
            hold off
            G_A = area(i);
            G_H = amp(i);
            testG = 1;
            else
            hh = msgbox(['more than 1 peaks within ' num2str(peak_assign) ' cm-1 of the assigne D1 peak location the peak assignment for ratio calculation may be incorrect'],'error','error');
            end
        end
    end
    D2_A = 0;
    peak_assign
    if testG == 1 && testD ==1 && (get(handles.legend_on_off,'Value') == get(handles.RatioCalc,'Max'))
    legend([h0 h1 h2],'total simulated profile','D1 peak','G peak',2)
    end
end

if (get(handles.RatioCalc,'Value') == get(handles.RatioCalc,'Max'))
    set(handles.R2_res_txt, 'String', 'R2 = whattttt');
    set(handles.R1_res_txt, 'String', 'R1 = whattttt');

    if D1_A && G_A
        R2 = D1_A./(G_A + D1_A+D2_A)
        R1 = D1_H./G_H;
        handles.R1 = R1;
        handles.R2 = R2;
        set(handles.R2_res_txt, 'String', ['R2 = ',num2str(R2,3)]);
        set(handles.R1_res_txt, 'String', ['R1 = ',num2str(R1,3)]);
    else
        h = msgbox('please click on the D peak center and G peak center buttons to refine the rough position','error','error')
    end
end

% create the figure to be exported
     
clf(figure(1))
figure(1);

     hax=axes('Position',[0.1,0.35,0.85,0.63]);
     plot(hax,x,y)
     hold on
     for i = 1:nbpeaks
        plot(x,eachFit(:,i),'k');
     end
     plot(hax,x,FittedCurve,'r')
     set(hax,'XTick',[])
     set(hax,'XTickLabel',[])
     hold off
     xlim([xmin xmax])
     ylabel('Intensity (cts)')
     hax = axes('Position',[0.1,0.1,0.85,0.20]);
     plot(hax,x,diff,'k')
          xlim([xmin xmax])
     xlabel('Raman Shift (cm^-^1)')
     filename = [handles.FileName '.pdf'];
     print(figure(1),'-dpdf', filename)
outputdata = [x y FittedCurve eachFit];
filename = [handles.FileName 'fit.csv'];
dlmwrite(filename,outputdata);
set(handles.Switch_to_New_Params,'Enable','off') 
guidata(hObject, handles);


% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DirectoryPath = handles.PathName;
[file0,PathName,FilterIndex] = uigetfile([DirectoryPath,'/*.csv;*.txt;*.asc']);
file = [PathName,file0];
handles.PathName = PathName;
szF = length(file0)-4;
handles.FileName = [handles.PathName file0(1:szF)];
axes(handles.Fit_figure);
if ~isequal(file, 0)
    A = importdata(file);
    handles.data = A;
    Plot_No_fit_Callback(hObject, eventdata, handles)
    ylabel('intensity')
handles.data_loaded = 1;
if handles.params_loaded
    set(handles.simulate_data,'Enable','on') 
    set(handles.Fit_Data,'Enable','on') 
end
guidata(hObject, handles);

end



% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
     set(hObject,'BackgroundColor','white');
end

function nb_peakstxt_Callback(hObject, eventdata, handles)
% hObject    handle to nb_peakstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
get(hObject,'String');
handles.nb_peaks = str2double(get(hObject,'String'));
handles.data_loaded = 1;

test_valid_start(hObject, eventdata, handles)

guidata(hObject, handles);

function test_valid_start(hObject, eventdata, handles)
tptxt = uicontrol(handles.nb_peakstxt);
set(tptxt,'backgroundColor','default')

if handles.positions ==0
    handles.positions  = zeros(1,handles.nb_peaks);
    set(handles.positionstxt,'String',num2str(handles.positions));
elseif length(handles.positions) < handles.nb_peaks
    tptxt = uicontrol(handles.positionstxt);
    set(tptxt,'backgroundColor','red')
    handles.data_loaded = 0;
elseif length(handles.positions) > handles.nb_peaks
    tptxt = uicontrol(handles.nb_peakstxt);
    set(tptxt,'backgroundColor','red')
else
    tptxt = uicontrol(handles.positionstxt);
    set(tptxt,'backgroundColor','default')
end
if handles.widths ==0
    handles.widths  = zeros(1,handles.nb_peaks);
    set(handles.widthstxt,'String',num2str(handles.widths));
elseif length(handles.widths) < handles.nb_peaks
    tptxt = uicontrol(handles.widthstxt);
    set(tptxt,'backgroundColor','red')
    handles.data_loaded = 0;
    elseif length(handles.widths) > handles.nb_peaks
    tptxt = uicontrol(handles.nb_peakstxt);
    set(tptxt,'backgroundColor','red')
else
    tptxt = uicontrol(handles.widthstxt);
    set(tptxt,'backgroundColor','default')
end
if handles.amplitudes ==0
    handles.amplitudes  = zeros(1,handles.nb_peaks);
    set(handles.ampstxt,'String',num2str(handles.amplitudes));
elseif length(handles.amplitudes) < handles.nb_peaks
    tptxt = uicontrol(handles.ampstxt);
    set(tptxt,'backgroundColor','red')
    handles.data_loaded = 0;
elseif length(handles.amplitudes) > handles.nb_peaks
tptxt = uicontrol(handles.nb_peakstxt);
set(tptxt,'backgroundColor','red')
else
    tptxt = uicontrol(handles.ampstxt);
    set(tptxt,'backgroundColor','default')
end
if handles.ratios ==0
    handles.ratios  = zeros(1,handles.nb_peaks);
    set(handles.ratiostxt,'String',num2str(handles.ratios));    
elseif length(handles.ratios) < handles.nb_peaks
    tptxt = uicontrol(handles.ratiostxt);
    set(tptxt,'backgroundColor','red')
    handles.data_loaded = 0;
elseif length(handles.ratios) > handles.nb_peaks
    tptxt = uicontrol(handles.nb_peakstxt);
    set(tptxt,'backgroundColor','red')
else
    tptxt = uicontrol(handles.ratiostxt);
    set(tptxt,'backgroundColor','default')
end

if handles.data_loaded ~= 0 
    set(handles.simulate_data,'Enable','on') 
    set(handles.Fit_Data,'Enable','on') 
else
    set(handles.simulate_data,'Enable','off') 
    set(handles.Fit_Data,'Enable','off') 
end
uicontrol(handles.simulate_data)
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function nb_peakstxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nb_peakstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function positionstxt_Callback(hObject, eventdata, handles)
% hObject    handle to positionstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)'
p = textscan(get(hObject,'String'),'%f',50);
handles.positions = p{1}';
test_valid_start(hObject, eventdata, handles)

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function positionstxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to positionstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function widthstxt_Callback(hObject, eventdata, handles)
% hObject    handle to widthstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
w = textscan(get(hObject,'String'),'%f',50);
handles.widths = w{1}';
test_valid_start(hObject, eventdata, handles)

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function widthstxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to widthstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function ampstxt_Callback(hObject, eventdata, handles)
% hObject    handle to ampstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
a = textscan(get(hObject,'String'),'%f',50);
handles.amplitudes = a{1}';
test_valid_start(hObject, eventdata, handles)

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function ampstxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ampstxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function ratiostxt_Callback(hObject, eventdata, handles)
% hObject    handle to ratiostxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
r = textscan(get(hObject,'String'),'%f',50);
handles.ratios = r{1}';
test_valid_start(hObject, eventdata, handles)

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function ratiostxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ratiostxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Xmintxt_Callback(hObject, eventdata, handles)
% hObject    handle to Xmintxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
get(hObject,'String');
handles.Xmin = str2double(get(hObject,'String'));
Plot_No_fit_Callback(hObject, eventdata, handles)
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Xmintxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Xmintxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Xmaxtxt_Callback(hObject, eventdata, handles)
% hObject    handle to Xmaxtxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
get(hObject,'String');
handles.Xmax = str2double(get(hObject,'String'));
Plot_No_fit_Callback(hObject, eventdata, handles)
guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of Xmaxtxt as text
%        str2double(get(hObject,'String')) returns contents of Xmaxtxt as a double

% --- Executes during object creation, after setting all properties.
function Xmaxtxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Xmaxtxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in Plot_No_fit.
function Plot_No_fit_Callback(hObject, eventdata, handles)
% hObject    handle to Plot_No_fit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.Fit_figure);
A = handles.data;
% if ~isequal(file, 0)
%     A = importdata(file);
    plot(A(:,1),A(:,2),'k');
    Xmin = handles.Xmin;
    Xmax = handles.Xmax;
    xlim([Xmin Xmax]);


function center_rangetxt_Callback(hObject, eventdata, handles)
% hObject    handle to center_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
p = textscan(get(hObject,'String'),'%f',50);
handles.position_range = p{1}';
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function center_rangetxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to center_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function width_rangetxt_Callback(hObject, eventdata, handles)
% hObject    handle to width_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

p = textscan(get(hObject,'String'),'%f',50);
handles.width_range = p{1}';
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function width_rangetxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to width_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function amp_rangetxt_Callback(hObject, eventdata, handles)
% hObject    handle to amp_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
p = textscan(get(hObject,'String'),'%f',50);
handles.amplitude_range = p{1}';
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function amp_rangetxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to amp_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ratio_rangetxt_Callback(hObject, eventdata, handles)
% hObject    handle to ratio_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
p = textscan(get(hObject,'String'),'%f',50);
handles.ratio_range = p{1}';
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function ratio_rangetxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ratio_rangetxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Switch_to_New_Params.
function Switch_to_New_Params_Callback(hObject, eventdata, handles)
% hObject    handle to Switch_to_New_Params (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Spositions = num2str(0.01.*round(100.*(handles.fitted_positions)));
set(handles.positionstxt,'String',Spositions);
Swidths = num2str(0.01.*round(100.*(handles.fitted_width)));
set(handles.widthstxt,'String',Swidths);
Samps = num2str(0.01.*round(100.*(handles.fitted_amplitudes)));
set(handles.ampstxt,'String',Samps);
Sratios = num2str(0.01.*round(100.*(handles.fitted_ratio)))
set(handles.ratiostxt,'String',Sratios);

handles.positions = handles.fitted_positions;
handles.widths = handles.fitted_width;
handles.amplitudes = handles.fitted_amplitudes;
handles.ratios = handles.fitted_ratio;


guidata(hObject, handles);

% --- Executes on button press in export_params.
function export_params_Callback(hObject, eventdata, handles)
% hObject    handle to export_params (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Spositions = num2str(handles.fitted_positions,'% 4.2f');
Swidths = num2str(handles.fitted_width,'% 3.1f');
Samps = num2str(handles.fitted_amplitudes,'% 5.2f');
Sratios = num2str(handles.fitted_ratio,'% 2.1f');
Srangemin = num2str(handles.Xmin);
Srangemax = num2str(handles.Xmax);
Sarea = num2str(handles.fitted_area,'% 4.0f');
SR1 = num2str(handles.R1,'% 4.3f');
SR2 = num2str(handles.R2,'% 4.3f');
D1_Center_Err = handles.D1Err;
D1_Center_Error = (D1_Center_Err(2)-D1_Center_Err(1))./2;
D1_Center = D1_Center_Err(1) + D1_Center_Error;
G_Center_Err = handles.GErr ;
G_Center_Error = (G_Center_Err(2)-G_Center_Err(1))./2;
G_Center = G_Center_Err(1) + G_Center_Error;


% area = handles.fitted_area(:);
L1 = {'Positions  ' Spositions};
L2 = {'Widths     ' Swidths};
L3 = {'Amplitudes ' Samps};
L4 = {'Ratio      ' Sratios};
L5 = {'Range_Min  ' Srangemin};
L6 = {'Range_Max  ' Srangemax};
L7 = {'area       ' Sarea};
L8 = {['R1         ' num2str(handles.R1,'%4.3f') '  1s ' num2str(handles.R1Err,'% 4.3f')]};
L9 = {['R2         ' num2str(handles.R2,'%4.3f') '  1s ' num2str(handles.R2Err,'% 4.3f')]};
L10 = {['D1 center = ' num2str(D1_Center,'%6.2f') ' +/- ' num2str(D1_Center_Error,'%6.2f')]};
L11 = {['G  center = ' num2str(G_Center,'%6.2f') ' +/- ' num2str(G_Center_Error,'%6.2f')]};


filename = [handles.FileName '_parameter_file.txt'];
fid = fopen(filename,'w');
fprintf(fid,'%s %s\n',L1{:});
fprintf(fid,'%s %s\n',L2{:});
fprintf(fid,'%s %s\n',L3{:});
fprintf(fid,'%s %s\n',L4{:});
fprintf(fid,'%s %s\n',L5{:});
fprintf(fid,'%s %s\n',L6{:});
fprintf(fid,'%s %s\n',L7{:});
fprintf(fid,'%s\n',L8{:});
fprintf(fid,'%s\n',L9{:});
fprintf(fid,'%s\n',L10{:});
fprintf(fid,'%s\n',L11{:});
if get(handles.Saddle_OnOff,'Value')== 1
    L12 = {['fit saddle = ' num2str(handles.Saddle_fit,'%4.2f') ' Data saddle = ' num2str(handles.Saddle_data,'%4.2f')]};
    fprintf(fid,'%s\n',L12{:});
end
if length(handles.fitted_positions) == 2
    L12 = {['Distance between the 2 peaks = ' num2str(handles.D_to_G,'%4.2f') ' cm-1']};
    fprintf(fid,'%s\n',L12{:});
end
if (get(handles.Slope_bkg,'Value') == get(handles.Slope_bkg,'Max'))
    L12 = {['background total intensity = ' num2str(handles.bkgInt,'%4.2f')]};
    L13 = {['Signal to background ratio around 1350 cm-1 = ' num2str(handles.bkgRatio_1350,'%4.8f')]};
    L14 = {['Signal to background ratio around 1600 cm-1 = ' num2str(handles.bkgRatio_1600,'%4.8f')]};
    L15 = {['Background slope (counts/cm-1) = ' num2str(handles.slope,'%4.6f')]};
    L16 = {['Signal around 1350 cm-1 to slope ratio = ' num2str(handles.slopeRatio_1350,'%4.6f')]};
    L17 = {['Signal around 1600 cm-1 to slope ratio = ' num2str(handles.slopeRatio_1350,'%4.6f')]};
        
    fprintf(fid,'%s\n',L12{:});
    fprintf(fid,'%s\n',L13{:});
    fprintf(fid,'%s\n',L14{:});
    fprintf(fid,'%s\n',L15{:});
    fprintf(fid,'%s\n',L16{:});
    fprintf(fid,'%s\n',L17{:});
end

fclose(fid);

guidata(hObject, handles);


% --- Executes on button press in RatioCalc.
function RatioCalc_Callback(hObject, eventdata, handles)
% hObject    handle to RatioCalc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RatioCalc


% --- Executes on button press in D1_Center.
function D1_Center_Callback(hObject, eventdata, handles)
% hObject    handle to D1_Center (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.Fit_figure);
[x,y] = ginput(1)
handles.roughD1pos = x;
if x< 1295 || x > 1370
   hh = msgbox({'Are you sure you clicked in the right place, your peak should be around 1330cm-1';['the selected position is ' num2str(x) ' cm-1']},'warning!!!','error')
end
guidata(hObject, handles);


% --- Executes on button press in G_center.
function G_center_Callback(hObject, eventdata, handles)
% hObject    handle to G_center (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.Fit_figure);
[x,y] = ginput(1)
handles.roughGpos = x;
if x< 1550 || x > 1650
   hh = msgbox({'Are you sure you clicked in the right place, your peak should be around 1600cm-1';['the selected position is ' num2str(x) ' cm-1']},'warning!!!','error')
end
guidata(hObject, handles);


% --- Executes on button press in Slope_bkg.
function Slope_bkg_Callback(hObject, eventdata, handles)
% hObject    handle to Slope_bkg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Slope_bkg


% --- Executes on button press in D2_Center.
function D2_Center_Callback(hObject, eventdata, handles)
% hObject    handle to D2_Center (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.Fit_figure);
[x,y] = ginput(1)
handles.roughD2pos = x;
if x> 1680 || x < 1550
   hh = msgbox({'Are you sure you clicked in the right place, your peak should be around 1600cm-1';['the selected position is ' num2str(x) ' cm-1']},'warning!!!','error')
end
guidata(hObject, handles);


% --- Executes on button press in D2_visible.
function D2_visible_Callback(hObject, eventdata, handles)
% hObject    handle to D2_visible (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of D2_visible


% --- Executes on button press in select_param.
function select_param_Callback(hObject, eventdata, handles)
% hObject    handle to select_param (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DirectoryPath = handles.PathName;
[file0,PathName,FilterIndex] = uigetfile([DirectoryPath,'*.txt']);
file = [PathName,file0];
handles.PathName = PathName;
% szF = length(file0)-4;
% handles.FileName = [handles.PathName file0(1:szF)];
% axes(handles.Fit_figure);
if ~isequal(file, 0)
 param = importdata(file);
set(handles.positionstxt,'String',num2str(param.data(1,:)));
set(handles.widthstxt,'String',num2str(param.data(2,:)));
set(handles.ampstxt,'String',num2str(param.data(3,:)));
set(handles.ratiostxt,'String',num2str(param.data(4,:)));
set(handles.Xmintxt,'String',num2str(param.data(5,1)));
set(handles.Xmaxtxt,'String',num2str(param.data(6,1)));

set(handles.nb_peakstxt,'String',num2str(length(param.data(1,:))));

handles.positions = param.data(1,:);
handles.widths = param.data(2,:);
handles.amplitudes = param.data(3,:);
handles.ratios = param.data(4,:);
handles.Xmin = param.data(5,1);
handles.Xmax = param.data(6,1);
handles.nb_peaks = length(param.data(1,:));
guidata(hObject, handles);
end




% --- Executes on button press in legend_on_off.
function legend_on_off_Callback(hObject, eventdata, handles)
% hObject    handle to legend_on_off (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of legend_on_off


% --- Executes on button press in Fine_assignment.
function Fine_assignment_Callback(hObject, eventdata, handles)
% hObject    handle to Fine_assignment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Fine_assignment



function Man_bkg_adj_txt_Callback(hObject, eventdata, handles)
% hObject    handle to Man_bkg_adj_txt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Man_bkg_adj_txt as text
%        str2double(get(hObject,'String')) returns contents of Man_bkg_adj_txt as a double
get(hObject,'String');
handles.Man_bkg_adj = str2double(get(hObject,'String'));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Man_bkg_adj_txt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Man_bkg_adj_txt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Saddle_OnOff.
function Saddle_OnOff_Callback(hObject, eventdata, handles)
% hObject    handle to Saddle_OnOff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Saddle_OnOff



function Nb_acquisitions_Callback(hObject, eventdata, handles)
% hObject    handle to Nb_acquisitions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
get(hObject,'String');
handles.nbAcquisitions = str2double(get(hObject,'String'));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Nb_acquisitions_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Nb_acquisitions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
